import greenfoot.*;
import java.awt.Color;
/**
 * Write a description of class testWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class House extends World
{
    private Link Hero;
    
    private static GreenfootImage bg = new GreenfootImage(1, 1);
    private static GreenfootImage mask = new GreenfootImage("House.png");
    private static GreenfootImage tempBG = new GreenfootImage(900, 600);
    
    private Color wall = Color.black;
    private Color doorup = Color.blue;
    private Color doorroom = Color.green;
    
    private int scrollPosX = -123;
    private int scrollPosY = 0;
    
    private boolean noup;
    private boolean noright;
    private boolean noleft;
    private boolean nodown;
    /**
     * Constructor for objects of class testWorld.
     **/
    public House()
    {    
        super(900, 600, 1, false);
        Hero = new Link();
        addObject(Hero, 399, 173);
        setPaintOrder(Link.class, Background.class);
        loadImage();
    }
    
    public void act()
    {
        collided();
        move();
        loadImage();
    }
    
    private void move()
    {
        if (Greenfoot.isKeyDown("up") && !noup)
        {
            scrollPosY++;
            scrollPosY++;
            scrollPosY++;
        }
        if (Greenfoot.isKeyDown("down") && !nodown)
        {
            scrollPosY--;
            scrollPosY--;
            scrollPosY--;
        }
        if (Greenfoot.isKeyDown("left") && !noleft)
        {
            scrollPosX++;
            scrollPosX++;
            scrollPosX++;
        }
        if (Greenfoot.isKeyDown("right") && !noright)
        {
            scrollPosX--;
            scrollPosX--;
            scrollPosX--;
        }
    }
    
    public void collided()
    {
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX + 20, getHero().getY() - scrollPosY))))
        {
            noright = true;
        }
        else
        {
            noright = false;
        }
        
        if ((doorup.equals(mask.getColorAt(getHero().getX() - scrollPosX - 20, getHero().getY() - scrollPosY))))
        {
            World upstairs = new Upstairs();
            Greenfoot.setWorld(upstairs);
        }
        
        if ((doorroom.equals(mask.getColorAt(getHero().getX() - scrollPosX - 20, getHero().getY() - scrollPosY))))
        {
            noleft = true;
            if (Greenfoot.isKeyDown("x"))
            {
                World room = new Bedroom();
                Greenfoot.setWorld(room);
            }   
        }
        else if ((!wall.equals(mask.getColorAt(getHero().getX() - scrollPosX - 20, getHero().getY() - scrollPosY))) && !(doorup.equals(mask.getColorAt(getHero().getX() - scrollPosX - 20, getHero().getY() - scrollPosY))))
        {
            noleft = false;
        }
        
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX - 20, getHero().getY() - scrollPosY))))
        {
            noleft = true;
        }
        else
        {
            noleft = false;
        }
        
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX, getHero().getY()  - scrollPosY - 20))))
        {
            noup = true;
        }
        else
        {
            noup = false;
        }
        
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX, getHero().getY()  - scrollPosY + 20))))
        {
            nodown = true;
        }
        else
        {
            nodown = false;
        }
    }
    
    public void setScrollpos(int x, int y)
    {
        scrollPosX -= x;
        scrollPosY -= y;
    }
    
    private void loadImage()
    {
        bg.scale(1000, 1000);
        tempBG.clear();
        setBackground(tempBG);
        tempBG.drawImage(mask, scrollPosX, scrollPosY);
        setBackground(tempBG);
    }

    public Link getHero()
    {
        return Hero;
    }
}
