import greenfoot.*;
import java.awt.Color;
/**
 * Write a description of class testWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class testWorld extends World
{
    private Link Hero;
    private Tiles tiles;
    private Background back;
    
    private static GreenfootImage bg = new GreenfootImage("Yay.png");
    private static GreenfootImage mask = new GreenfootImage("Yay copy.png");
    private static GreenfootImage tempBG = new GreenfootImage(900, 650);
    
    private Color wall = Color.black;
    
    private int scrollPosX = 0;
    private int scrollPosY = 0;
    
    private boolean noup;
    private boolean noright;
    private boolean noleft;
    private boolean nodown;
    /**
     * Constructor for objects of class testWorld.
     **/
    public testWorld()
    {    
        super(900, 650, 1, false);
        Hero = new Link();
        addObject(Hero, 450, 325);
        setPaintOrder(Link.class, Background.class);
        loadImage();
    }
    
    public void act()
    {
        collided();
        move();
        loadImage();
    }
    
    private void move()
    {
        if (Greenfoot.isKeyDown("up") && !noup)
        {
            scrollPosY++;
            scrollPosY++;
            scrollPosY++;
        }
        if (Greenfoot.isKeyDown("down") && !nodown)
        {
            scrollPosY--;
            scrollPosY--;
            scrollPosY--;
        }
        if (Greenfoot.isKeyDown("left") && !noleft)
        {
            scrollPosX++;
            scrollPosX++;
            scrollPosX++;
        }
        if (Greenfoot.isKeyDown("right") && !noright)
        {
            scrollPosX--;
            scrollPosX--;
            scrollPosX--;
        }
    }
    
    public void collided()
    {
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX + 20, getHero().getY() - scrollPosY))))
        {
            noright = true;
        }
        else
        {
            noright = false;
        }
        
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX - 20, getHero().getY() - scrollPosY))))
        {
            noleft = true;
        }
        else
        {
            noleft = false;
        }
        
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX, getHero().getY()  - scrollPosY - 20))))
        {
            noup = true;
        }
        else
        {
            noup = false;
        }
        
        if ((wall.equals(mask.getColorAt(getHero().getX() - scrollPosX, getHero().getY()  - scrollPosY + 20))))
        {
            nodown = true;
        }
        else
        {
            nodown = false;
        }
    }
    
    public void setScrollpos(int x, int y)
    {
        scrollPosX -= x;
        scrollPosY -= y;
    }
    
    private void loadImage()
    {
        bg.scale(1000, 1000);
        mask.scale(1000, 1000);
        tempBG.drawImage(bg, scrollPosX, scrollPosY);
        setBackground(tempBG);
    }

    public Link getHero()
    {
        return Hero;
    }
    
    public Background getBack()
    {
        return back;
    }
    
    public Tiles getTiles()
    {
        return tiles;
    }
}
