import greenfoot.*;
import java.awt.Color;

public class Link extends Actor
{

    public int points = 0;
    private int counter = 1;
    private int deathtoll = 0;
    public int death = 0;
    private boolean fup;
    private boolean fown;
    private boolean feft;
    private boolean fight;
    public boolean stopup;
    public boolean stopdown;
    public boolean stopleft;
    public boolean stopright;
    
    public void act() 
    {
        move();
        fimage();
    }
    
    public void move()
    {
        if (Greenfoot.isKeyDown("right"))
        {
            animateRight();
        }
        
        if (Greenfoot.isKeyDown("left"))
        {
            animateLeft();
        }
        
        if (Greenfoot.isKeyDown("up"))
        {
            animateUp();
        }
        
        if (Greenfoot.isKeyDown("down"))
        {
            animateDown();
        }
    }
    
    public void die()
    {
        if (death == 1)
        {
        World world = getWorld();
        setLocation(world.getWidth()/2, world.getHeight()/2);
         if (deathtoll <= 3 || deathtoll == 15 || deathtoll == 27)
            {
                setImage("LL5.png");  
            }
            else if (deathtoll == 6 || deathtoll == 18 || deathtoll == 30)
            {
                setImage("LD1.png");
            }
            else if (deathtoll == 9 || deathtoll == 21 || deathtoll == 33)
            {
                setImage("LR1.png");
            }
            else if (deathtoll == 12 || deathtoll == 24 || deathtoll == 36)
            {
                setImage("LU2.png");
            }
            else if (deathtoll == 37)
            {
                setImage("LinkDead.gif");
            }
            deathtoll++;
         if (deathtoll > 37)
         {
            Greenfoot.stop();
         }
        }
    }
    
    public void animateRight()
    {
        
        
        
            if (counter <= 2)
            {
                setImage("LR1.png");
                fight = true;
            }
            else if (counter == 4)
            {
                setImage("LR2.png");
                fight = false;
            }
            else if (counter == 6)
            {
                setImage("LR3.png");
            }
            else if (counter == 8)
            {
                setImage("LR4.png");
            }
            else if (counter == 10)
            {
                setImage("LR5.png");
            }
            else if (counter == 12)
            {
                setImage("LR6.png");
            }
            else if (counter == 14)
            {
                setImage("LR7.png");
            }
            else if (counter == 16)
            {
                setImage("LR8.png");
            }

            counter++;
            if (counter > 16)
            {
                counter = 0;
            }
        
        
    }
    
    public void animateLeft()
    {
        if (counter <= 2)
            {
                setImage("LL1.png");
                feft = true;
            }
            else if (counter == 4)
            {
                setImage("LL2.png");
                feft = false;
            }
            else if (counter == 6)
            {
                setImage("LL3.png");
            }
            else if (counter == 8)
            {
                setImage("LL4.png");
            }
            else if (counter == 10)
            {
                setImage("LL5.png");
            }
            else if (counter == 12)
            {
                setImage("LL6.png");
            }
            else if (counter == 14)
            {
                setImage("LL7.png");
            }
            else if (counter == 16)
            {
                setImage("LL8.png");
            }

        counter++;
            if (counter > 16)
            {
                counter = 0;
            }
        
        
    }
    
    public void animateUp()
    {
        if (counter <= 2)
        {
                setImage("LU1.png");
                fup = true;
        }
        else if (counter == 4)
        {
                setImage("LU2.png");
                fup = false;
        }
        else if (counter == 6)
        {
                setImage("LU3.png");
        }
        else if (counter == 8)
        {
                setImage("LU4.png");
        }
        else if (counter == 10)
        {
                setImage("LU5.png");
        }
        else if (counter == 12)
        {
            setImage("LU6.png");
        }
        else if (counter == 14)
        {
            setImage("LU7.png");
        }

        counter++;
        if (counter > 14)
        {
            counter = 0;
        }
    }
    
    public void animateDown()
    {
            if (counter <= 2)
            {
                setImage("LD1.png");
                fown = true;
            }
            else if (counter == 4)
            {
                setImage("LD2.png");
                fown = false;
            }
            else if (counter == 6)
            {
                setImage("LD3.png");
            }
            else if (counter == 8)
            {
                setImage("LD4.png");
            }
            else if (counter == 10)
            {
                setImage("LD5.png");
            }
            else if (counter == 12)
            {
                setImage("LD6.png");
            }
            else if (counter == 14)
            {
                setImage("LD7.png");
            }

            counter++;
            if (counter > 14)
            {
            counter = 0;
            }
    }
    
    private void detect()
    {
        if (getWorld().getColorAt(getX() + 2, getY()) == Color.GREEN)
        {
            stopright = true;
        }
        
        if (getWorld().getColorAt(getX() - 2, getY())  == Color.GREEN)
        {
            stopleft = true;
        }
        
        if (getWorld().getColorAt(getX(), getY() - 2)  == Color.GREEN)
        {
            stopup = true;
        }
        
        if (getWorld().getColorAt(getX(), getY() + 2)  == Color.GREEN)
        {
            stopdown = true;
        }
    }
    
    private void fimage()
    {
        while (!fown && !Greenfoot.isKeyDown("down"))
        {
            animateDown();
        }
        
        while (!fup && !Greenfoot.isKeyDown("up"))
        {
            animateUp();
        }
        
        while (!feft && !Greenfoot.isKeyDown("left"))
        {
            animateLeft();
        }
        
        while (!fight && !Greenfoot.isKeyDown("right"))
        {
            animateRight();
        }
    }
}
